---

- name: Ensure system dependencies installed
  ansible.builtin.apt:
    name:
      - lsb-release
      - apt-transport-https
      - gnupg
    state: present
    cache_valid_time: 3600
  tags:
    - setup-all
    - install-all

- name: Ensure LSB facts reloaded
  ansible.builtin.setup:
    filter: ansible_lsb*
  tags:
    - setup-all
    - install-all

- name: Ensure docker apt key is trusted
  ansible.builtin.apt_key:
    url: "https://download.docker.com/linux/{{ ansible_distribution | lower }}/gpg"
    id: "{{ system_docker_aptkey }}"
    state: present
  tags:
    - setup-all
    - install-all

- name: Ensure docker apt key is saved
  ansible.builtin.get_url:
    url: "https://download.docker.com/linux/{{ ansible_distribution | lower }}/gpg"
    dest: /etc/apt/trusted.gpg.d/docker.asc
    mode: 0644
    force: true
  tags:
    - setup-all
    - install-all

- name: Ensure old docker repository is disabled
  ansible.builtin.file:
    path: "/etc/apt/sources.list.d/{{ item }}"
    state: absent
  with_items:
    - download_docker_com_linux_ubuntu.list
    - download_docker_com_linux_ubuntu.list.distUpgrade
    - download_docker_com_linux_debian.list
  tags:
    - setup-all
    - install-all

- name: Ensure docker repository is enabled
  ansible.builtin.apt_repository:
    repo: "deb [signed-by=/etc/apt/trusted.gpg.d/docker.asc] https://download.docker.com/linux/{{ ansible_distribution | lower }} {{ ansible_distribution_release }} stable"
    filename: docker
    state: present
    update_cache: yes
  tags:
    - setup-all
    - install-all

- name: Ensure APT packages are installed
  ansible.builtin.apt:
    name:
      - docker-ce
      - "python{{ '3' if ansible_python.version.major == 3 else '' }}-docker"
    state: present
    cache_valid_time: 3600
  tags:
    - setup-all
    - install-all

- name: Ensure docker is started and autoruns
  ansible.builtin.service:
    name: docker
    state: started
    enabled: true
  tags:
    - setup-all
    - install-all
